\section{Extensive Example and Demo}

\begin{frame}[fragile]{Demo – Linear Workflow}
	\begin{lstlisting}[language=qosagg, gobble=4, caption={Linear online shop workflow}]
		workflow {
			graph: Search → AddToBasket → Checkout → Payment → Shipping → Confirmation;
			@\pause@
			provision search_ads for Search;
			provision basket_ads for AddToBasket;
			@…@
			provision search_sb for Search;
			@…@
		}
	\end{lstlisting}
\end{frame}

\begin{frame}[fragile]{Demo – Attributes and Aggregation}
	\begin{lstlisting}[language=qosagg, gobble=4, caption={Adding attributes and aggregation}]
		workflow {
			graph: Search → AddToBasket → Checkout → Payment → Shipping → Confirmation;

			aggregation cost: sum;
			aggregation latency: sum;

			provision search_ads for Search: cost = 27, latency = 17.3;
			provision basket_ads for AddToBasket: cost = 16, latency = 6.7;
			@…@
		}
	\end{lstlisting}
\end{frame}

\begin{frame}[fragile]{Demo – Attributes and Aggregation}
	\begin{lstlisting}[language=minizinc, gobble=4, caption={Simple constraint model using the online shop workflow}]
		include "shop_wf.mzn";
		solve minimize wf_aggregated_cost + wf_aggregated_latency;
	\end{lstlisting}
\end{frame}

\begin{frame}[fragile]{Demo – Loop, Choice and Parallel Composition}
	\begin{figure}
		\centering
		\resizebox{!}{.8\textheight}{\input{img/shop_workflow}}
		\caption{Visualization of the workflow for our online shop}
	\end{figure}
\end{frame}

\begin{frame}[fragile]{Demo – Loop, Choice and Parallel Composition}
	\begin{lstlisting}[language=qosagg, gobble=4, caption={Workflow model for the extended workflow}]
		workflow {
			graph: (Search → AddToBasket)^4 → Checkout → (CreditCardPayment + OnAccountPayment) → (Shipping | Confirmation);

			aggregation cost: sum;
			aggregation latency: sum, max;

			@…@
		}
	\end{lstlisting}
\end{frame}

\begin{frame}[fragile]{Demo – Loop, Choice and Parallel Composition}
	\begin{lstlisting}[language=minizinc, gobble=4, caption={Enforcing user selection in the constraint model}]
		include "shop_wf.mzn";

		constraint wf_reachable[wf_CardPayment_inst];

		solve minimize wf_aggregated_cost + wf_aggregated_latency;
	\end{lstlisting}
\end{frame}

\begin{frame}[fragile]{Demo – Non-Constant Attributes}
	\begin{lstlisting}[language=minizinc, gobble=4, caption={Constraint model with subscription}]
		include "shop_wf.mzn";

		var bool: ads_subscription;
		var int: cost = wf_aggregated_cost + if ads_subscription then 23 else 0 endif;

		solve minimize cost + wf_aggregated_latency;

		@…@
	\end{lstlisting}
\end{frame}

\begin{frame}[fragile]{Demo – Non-Constant Attributes}
	\begin{lstlisting}[language=qosagg, gobble=4, caption={Workflow model with subscription}]
			@…@
			attribute cost of var int;
			aggregation cost: sum;
			aggregation latency: sum, max;

			provision search_ads for Search:
				cost = if ads_subscription then 17 else 27 endif, latency = 17.3;
			provision basket_ads for AddToBasket:
				cost = if ads_subscription then 11 else 16 endif, latency = 6.7;
			@…@
	\end{lstlisting}
\end{frame}

\begin{frame}[fragile]{Demo – Categories}
	\begin{lstlisting}[language=qosagg, gobble=4, caption={Workflow model with provider category}]
			@…@
			attribute cost of var int;
			aggregation cost: sum;
			aggregation latency: sum, max;
			attribute provider of PROVIDER;
			category provider;

			provision search_ads for Search:
				provider = ADS,
				cost = if ads_subscription then 17 else 27 endif, latency = 17.3;
			provision basket_ads for AddToBasket:
				provider = ADS, @…@
	\end{lstlisting}
\end{frame}

\begin{frame}[fragile]{Demo – Categories}
	\begin{lstlisting}[language=minizinc, gobble=4, caption={Constraint model with provider avoidance}]
		include "shop_wf.mzn";
		@…@
		solve minimize cost + wf_aggregated_latency + wf_all_category_changes;
		@…@
	\end{lstlisting}
\end{frame}

\begin{frame}[fragile]{Demo – Checkpoints}
	\begin{lstlisting}[language=minizinc, gobble=4, caption={Constraint model with latency at checkpoint}]
		include "shop_wf.mzn";
		@…@
		var float: latency =
			wf_checkpoints_latency[wf_Shipping_pre];
		solve minimize cost + latency + wf_all_category_changes;
		@…@
	\end{lstlisting}
\end{frame}

\begin{frame}[fragile]{Demo – Preference Model}
	\begin{lstlisting}[language=minibrass, gobble=4, caption={Preference model}]
		include "defs.mbr";

		PVS: cfn = new CostFunctionNetwork("cfn") {
			soft-constraint cost:
				'cost';
			soft-constraint latency:
				'latency' :: weights('2');
			soft-constraint catChanges:
				'wf_all_category_changes' :: weights('5');
		};
	
		solve cfn;
	\end{lstlisting}
\end{frame}

\begin{frame}[fragile]{Demo – Output}
	\begin{lstlisting}[gobble=4, caption={Output – Part 1}]
		Selection graph for wf:
			Search=search_e100 →
			AddToBasket=basket_ads →
			Search=search_e100 →
			AddToBasket=basket_ads →
			Search=search_e100 →
			AddToBasket=basket_ads →
			Search=search_e100 →
			AddToBasket=basket_ads →
			Checkout=checkout_ads →
			OnAccountPayment=onaacountpayment_sb →
			(Shipping=shipping_sb | Confirmation=confirmation_e100)
	\end{lstlisting}
\end{frame}

\begin{frame}[fragile]{Demo – Output}
	\begin{lstlisting}[gobble=4, caption={Output – Part 2}, firstnumber=13, escapechar=@]
		Latency: 88
		Cost: 140
		ADS subscription: false
		Aggregations for wf:
				cost: 140
				latency: 107.7
		Category changes for wf:
				provider: 0
				@Σ@ changes: 0
		Valuations: mbr_overall_global = 228; mbr_overall_local = 0.6949943869777885
	\end{lstlisting}
\end{frame}